diff -u src/smooth-tasks-fork/applet/SmoothTasks/PlasmaToolTip.cpp src/smooth-tasks-fork/applet/SmoothTasksX/PlasmaToolTip.cpp
--- src/smooth-tasks-fork/applet/SmoothTasks/PlasmaToolTip.cpp	2011-12-24 03:13:55.604361299 +0100
+++ src/smooth-tasks-fork/applet/SmoothTasksX/PlasmaToolTip.cpp	2011-12-24 03:11:00.000000000 +0100
@@ -91,7 +91,7 @@
 	}
 	
 	Plasma::ToolTipContent data;
-	TaskManager::TaskPtr taskPtr(task->task());
+	TaskManager::Task* taskPtr(task->task());
 	QList<WId> windows;
 	int desktop = -1;
 
diff -u src/smooth-tasks-fork/applet/SmoothTasks/SmoothToolTip.cpp src/smooth-tasks-fork/applet/SmoothTasksX/SmoothToolTip.cpp
--- src/smooth-tasks-fork/applet/SmoothTasks/SmoothToolTip.cpp	2011-12-24 03:13:55.605361287 +0100
+++ src/smooth-tasks-fork/applet/SmoothTasksX/SmoothToolTip.cpp	2011-12-24 03:10:24.000000000 +0100
@@ -474,7 +474,7 @@
 	foreach (WindowPreview *preview, m_previews) {
 		preview->show();
 
-		TaskManager::TaskPtr task = preview->task()->task();
+		TaskManager::Task* task = preview->task()->task();
 		
 		if (task && preview->task()->type() != Task::StartupItem && preview->task()->type() != Task::LauncherItem) {
 			winIds.append(task->window());
diff -u src/smooth-tasks-fork/applet/SmoothTasks/Task.cpp src/smooth-tasks-fork/applet/SmoothTasksX/Task.cpp
--- src/smooth-tasks-fork/applet/SmoothTasks/Task.cpp	2011-12-24 03:13:55.606361275 +0100
+++ src/smooth-tasks-fork/applet/SmoothTasksX/Task.cpp	2011-12-24 03:07:21.000000000 +0100
@@ -118,8 +118,8 @@
 }
 
 QString Task::text() const {
-	TaskManager::TaskPtr    task;
-	TaskManager::StartupPtr startup;
+	TaskManager::Task    *task;
+	TaskManager::Startup *startup;
 	
 	switch (type()) {
 	case StartupItem:
@@ -186,12 +186,23 @@
    return m_task ? m_task->task()->desktop() : -1;
 }
 
-TaskManager::TaskPtr Task::task() const {
-	return m_task ? m_task->task() : TaskManager::TaskPtr();
-}
-
-TaskManager::StartupPtr Task::startup() const {
-	return m_task ? m_task->startup() : TaskManager::StartupPtr();
+TaskManager::Task* Task::task() const {
+	if (m_task) {
+		return m_task->task();
+	} else {
+		TaskManager::Task *task;
+		return task;
+	}
+	//return m_task ? m_task->task() : ::TaskManager::Task task;
+}
+
+TaskManager::Startup* Task::startup() const {
+	if (m_task) {
+		return m_task->startup();
+	} else {
+		TaskManager::Startup* startup;
+		return startup;
+	}
 }
 
 int Task::taskCount() const {
@@ -309,7 +320,7 @@
 void Task::setWindowTask(TaskManager::TaskItem* taskItem) {
 	m_type = TaskItem;
 	if (m_task && m_task->task()) {
-		disconnect(m_task->task().constData(), 0, this, 0);
+		disconnect(m_task->task(), 0, this, 0);
 	}
 	
 	m_task = taskItem;
diff -u src/smooth-tasks-fork/applet/SmoothTasks/Task.h src/smooth-tasks-fork/applet/SmoothTasksX/Task.h
--- src/smooth-tasks-fork/applet/SmoothTasks/Task.h	2011-12-24 03:13:55.607361262 +0100
+++ src/smooth-tasks-fork/applet/SmoothTasksX/Task.h	2011-12-24 02:34:23.000000000 +0100
@@ -78,12 +78,12 @@
 	QString                 text() const;
 	QString                 description() const;
 	int                     desktop() const;
-	TaskManager::TaskPtr    task() const;
+	TaskManager::Task       *task() const;
 	TaskManager::AbstractGroupableItem *abstractItem() { return m_abstractItem; }
 	TaskManager::GroupPtr   group() const { return m_group; }
-	TaskManager::TaskItem  *taskItem() const { return m_task; }
+	TaskManager::TaskItem   *taskItem() const { return m_task; }
 	TaskManager::LauncherItem  *launcherItem() const { return m_launcher; }
-	TaskManager::StartupPtr startup() const;
+	TaskManager::Startup    *startup() const;
 	TaskFlags               flags() const { return m_flags; }
 	ItemType                type()  const { return m_type; }
 	void                    addMimeData(QMimeData* mimeData);
Only in src/smooth-tasks-fork/applet/SmoothTasksX: .Task.h.kate-swp
diff -u src/smooth-tasks-fork/applet/SmoothTasks/TaskItem.cpp src/smooth-tasks-fork/applet/SmoothTasksX/TaskItem.cpp
--- src/smooth-tasks-fork/applet/SmoothTasks/TaskItem.cpp	2011-12-24 03:13:55.610361223 +0100
+++ src/smooth-tasks-fork/applet/SmoothTasksX/TaskItem.cpp	2011-12-24 03:09:11.000000000 +0100
@@ -375,7 +375,7 @@
 
 void TaskItem::publishIconGeometry() {
 	QRect iconRect(iconGeometry());
-	TaskManager::TaskPtr task;
+	TaskManager::Task *task;
 	TaskManager::GroupPtr group;
 	
 	switch (m_task->type()) {
@@ -465,7 +465,7 @@
 }
 
 void TaskItem::mouseReleaseEvent(QGraphicsSceneMouseEvent *event) {
-	TaskManager::TaskPtr task;
+	TaskManager::Task* task;
 	
 	switch (event->button()) {
 	case Qt::LeftButton:
@@ -626,7 +626,7 @@
 }
 
 void TaskItem::activate() {
-	TaskManager::TaskPtr task;
+	TaskManager::Task* task;
 	
 	switch (m_task->type()) {
 	case Task::TaskItem:
Common subdirectories: src/smooth-tasks-fork/applet/SmoothTasks/Ui and src/smooth-tasks-fork/applet/SmoothTasksX/Ui
diff -u src/smooth-tasks-fork/applet/SmoothTasks/WindowPreview.cpp src/smooth-tasks-fork/applet/SmoothTasksX/WindowPreview.cpp
--- src/smooth-tasks-fork/applet/SmoothTasks/WindowPreview.cpp	2011-12-24 03:13:55.619361111 +0100
+++ src/smooth-tasks-fork/applet/SmoothTasksX/WindowPreview.cpp	2011-12-24 03:12:49.000000000 +0100
@@ -117,7 +117,7 @@
 	if (m_toolTip->previewsAvailable()) {
 		// determine preview size:
 		WId wid = 0;
-		TaskManager::TaskPtr task = m_task->task();
+		TaskManager::Task* task = m_task->task();
 		
 		if (task) {
 			wid = task->window();
@@ -297,7 +297,7 @@
 }
 
 void WindowPreview::highlightTask() {
-	TaskManager::TaskPtr task = m_task->task();
+	TaskManager::Task* task = m_task->task();
 	
 	if (task) {
 		m_toolTip->highlightTask(task->window());
@@ -325,7 +325,7 @@
 	m_toolTip->hide();
 	
         if(m_task->type() != Task::LauncherItem) {
-                TaskManager::TaskPtr task = m_task->task();
+                TaskManager::Task* task = m_task->task();
                 if (task) {
                         task->activate();
                 }
@@ -336,7 +336,7 @@
 }
 
 void WindowPreview::activateForDrop() {
-	TaskManager::TaskPtr task = m_task->task();
+	TaskManager::Task* task = m_task->task();
 	if (task) {
 		if (task->isMinimized()) {
 			task->restore();
@@ -347,7 +347,7 @@
 }
 
 void WindowPreview::closeTask() {
-	TaskManager::TaskPtr task = m_task->task();
+	TaskManager::Task* task = m_task->task();
 	if (task) {
 		task->close();
 	}
